package com.game.demo;

import javax.swing.*;
import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class PlaneGame extends JFrame {
    // 控制游戏状态
    public static int state = 0;
    Image offScreenImage = null;
    // 背景图对象
    bgClass bgObj = new bgClass(Constant.bgImage, 0, -1800, 2);
    // 建立我方飞机对象
    public PlaneObj planeObj = new PlaneObj(Constant.myImage, 190, 700, 20, 30, 0, this);
    // 游戏的从绘次数
    int count = 1;
    // 我方生命
    public static int life = 3;
    // 分数记录
    public static int score = 0;
    // 敌方飞机数量达到多少boss出现
    int enemtCount = 0;
    // 建立地方boss对象
    public BossObj bossObj = null;

    // 设置窗口基本样式
    public void launch(){
        // 设置窗口是否可见
        this.setVisible(true);
        // 设置窗口大小（单位，像素）
        this.setSize(Constant.GAME_WIDTH, Constant.GAME_HEIGHT);
        // 设置窗口位置(位置为屏幕中央)
        this.setLocationRelativeTo(null);
        // 设置窗口标题
        this.setTitle("怀旧自制飞机大战");
        // 加入生成的每一个对象
        Constant.gameObjList.add(bgObj);
        Constant.gameObjList.add(planeObj);

        // 添加鼠标点击事件
        this.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                // 判断如果点击界面且运行状态为0（未开始状态），将游戏状态更改为1(运行状态)
                if(e.getButton() == 1 && state == 0){
                    state = 1;
                    repaint();
                }
            }
        });

        // 按键检测
        this.addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                if(e.getKeyCode()==32){
                    switch(state){
                        case 1:
                            state = 4;
                            break;
                        case 4:
                            state = 1;
                            break;
                        default:
                    }
                }
            }
        });

        // 调用程序运行，间隔25毫秒绘制一次
        while(true){
            if(state == 1){
                createObj();
                repaint();
            }
            try {
                Thread.sleep(25);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    // 背景图片导入
    public void paint(Graphics g){
        if(offScreenImage == null){
            offScreenImage = createImage(Constant.GAME_WIDTH, Constant.GAME_HEIGHT);
        }
        Graphics gImage = offScreenImage.getGraphics();
        gImage.fillRect(0, 0, Constant.GAME_WIDTH, Constant.GAME_HEIGHT);
        // 初始状态（游戏未运行，准备阶段）
        if(state == 0){
            // 绘制游戏背景
            gImage.drawImage(Constant.bgImage, 0, 0, null);
            gImage.drawImage(Constant.bossImage, 190, 100, null);
            gImage.drawImage(Constant.explodeImage, 200, 400, null);
            // 在界面设置字体
            Constant.drawWord(gImage, "点击开始游戏", Color.yellow, 40, 110, 350);
        // 游戏开始
        }else if(state == 1){
            for(int i = 0;i < Constant.gameObjList.size();i++){
                Constant.gameObjList.get(i).paintSelf(gImage);
            }
            Constant.gameObjList.removeAll(Constant.removeList);
        // 游戏结束
        }else if(state == 2){
            gImage.drawImage(Constant.explodeImage, planeObj.getX()-35, planeObj.getY()-50, null);
            // 在界面设置字体
            Constant.drawWord(gImage, "游戏结束", Color.RED, 50, 110, 350);
        }else if(state == 3){
            gImage.drawImage(Constant.explodeImage, bossObj.getX(), bossObj.getX()+30, null);
            Constant.drawWord(gImage, "恭喜游戏潼关", Color.green, 50, 190, 250);
        }
        Constant.drawWord(gImage, "得分："+score, Color.green, 40, 30, 100);
        g.drawImage(offScreenImage, 0, 0, null);
        count++;
    }

    void createObj(){
        // 方子弹对象集合添加元素
        if(count % 15 == 0){
            Constant.shellObjList.add(new ShellObj(Constant.myshellImage, planeObj.getX()+12,planeObj.getY()-5, 14, 29, 5, this));
            Constant.gameObjList.add(Constant.shellObjList.get(Constant.shellObjList.size() - 1));
        }
        // 敌方飞机
        if(count % 15 == 0){
            Constant.enemyObjList.add(new EnemyObj(Constant.enemyImage, (int)(Math.random()*12)*50, 0, 57, 43, 5, this));
            Constant.gameObjList.add(Constant.enemyObjList.get(Constant.enemyObjList.size()-1));
            enemtCount += 1;
        }
        // 方子弹对象集合添加元素
        if(count % 15 == 0 && bossObj != null){
            Constant.bulletObList.add(new BulletObj(Constant.bulletImage, bossObj.getX()+76, bossObj.getY()+85, 15, 25, 5,this));
            Constant.gameObjList.add(Constant.bulletObList.get(Constant.bulletObList.size()-1));
        }
        if(enemtCount >= 100 && bossObj == null){
            bossObj = new BossObj(Constant.bossImage, 250, 30, 155, 100, 5, this);
            Constant.gameObjList.add(bossObj);

        }
    }

    // 程序入口
    public static void main(String[] args) {
        PlaneGame game = new PlaneGame();
        game.launch();
    }
}
